<?php
function smartermail_ClientArea($params) {
	
	$smUrl = addHttpToHostname($params["serverhostname"]);

    $paramaters = array(
        'AuthUserName' => $params["serverusername"],
        'AuthPassword' => $params["serverpassword"],
        'domainName'=> $params["domain"]
    );
	
	
    $wsGetProductInfoResult = sm_webServiceCall($smUrl."/Services/svcProductInfo.asmx?WSDL",$paramaters,"GetProductInfo");
	$version = explode(".", $wsGetProductInfoResult['GetProductInfoResult']['ProductVersion']);
	$showdetails = false;
	if($version[0] >= 14)
		$showdetails = true;
	
	
	
	//Call to get Domain Aliases
    $sm_GetAliases_ws_url = $smUrl."/Services/svcDomainAdmin.asmx?WSDL";
	if($showdetails)
	{
		$wsGetDomainInfoResult = sm_webServiceCall($sm_GetAliases_ws_url,$paramaters,"GetDomainInfo2");
		if(!is_null($wsGetDomainInfoResult['GetDomainInfo2Result']['Name']))
		{
			$showdetails = true;
		}
		else
		{
			$showdetails = false;
		}
	}
	
	$wsGetDomainSettingsResult = sm_webServiceCall($sm_GetAliases_ws_url,$paramaters,"GetDomainSettings");
	if($wsGetDomainSettingsResult['GetDomainSettingsResult']['MaxDomainUsers'] == 0)
		$wsGetDomainSettingsResult['GetDomainSettingsResult']['MaxDomainUsers'] = "∞";
	if($wsGetDomainSettingsResult['GetDomainSettingsResult']['MaxDomainAliases'] == 0)
		$wsGetDomainSettingsResult['GetDomainSettingsResult']['MaxDomainAliases'] = "∞";
	if($wsGetDomainSettingsResult['GetDomainSettingsResult']['MaxDomainSizeInMB'] == 0)
		$wsGetDomainSettingsResult['GetDomainSettingsResult']['MaxDomainSizeInMB'] = "∞";

    return array(
        'templatefile' => 'clientarea',
        'vars' => array(
            'domaininfo' => $wsGetDomainInfoResult,
            'domainsettings' => $wsGetDomainSettingsResult,
			'showdomaindetails' => $showdetails
        ),
    );
}
//used to configure options for the SmarterMail settings within the server settings.  Each option is called by 'configoption#'
function smartermail_ConfigOptions()
{
    $configarray = array(
        "SmarterMail Data Path" => array("Type"=>"text", "Size"=>"25", "Description"=>"Ex. C:\\SmarterMail\\Domains\\ NOTE: this would need to be consistent across all products"),
        "Outbound IP Address" => array("Type"=>"text", "Size"=>"25", "Description"=>"IP address used for outbound messages"),
        "Maximum Number of Domain Users" => array("Type"=>"text", "Size"=>"25", "Description"=>""),
        "Maximum Domain Size" => array("Type"=>"text", "Size"=>"25", "Description"=>"MB"),
        "Maximum Number of Domain Aliases" => array("Type"=>"text", "Size"=>"25", "Description"=>""),
        "Maximum Number of User Aliases" => array("Type"=>"text", "Size"=>"25", "Description"=>""),
        "Maximum Message Size" => array("Type"=>"text", "Size"=>"25", "Description"=>""),
        "Maximum Number of Recipients" => array("Type"=>"text", "Size"=>"25", "Description"=>""),
        "Maximum Number of Mailing Lists" => array("Type"=>"text", "Size"=>"25", "Description"=>""),
        "List Command Address" => array("Type"=>"text", "Size"=>"25", "Description"=>""),
        "Require SMTP Authentication" => array("Type"=>"yesno", "Description"=>"Check to require SMTP Authentication"),
        "Enable Domain Aliases" => array("Type"=>"yesno", "Description"=>""),
        "Enable Content Filtering" => array("Type"=>"yesno", "Description"=>""),
        "Enable users to modify spam settings" => array("Type"=>"yesno", "Description"=>""),
        "Enable Mailing Lists" => array("Type"=>"yesno", "Description"=>""),
        "SmarterMail Web Interface URL" => array("Type"=>"text", "Size"=>"25", "Description"=>"Ex. http://mail.example.com")
    );
    return $configarray;
}

//Used when a product is created within WHMCS.  This calls 'createdomain' web service on SmarterMail installation.
function smartermail_CreateAccount($params)
{
    $smUrl = addHttpToHostname($params["serverhostname"]);//$params["configoption16"];

    $paramaters = array(
        'AuthUserName' => $params["serverusername"],
        'AuthPassword' => $params["serverpassword"],
        'DomainName'=> $params["domain"],
        'Path'=> $params["configoption1"].$params["domain"],
        'PrimaryDomainAdminUserName'=> $params["username"],
        'PrimaryDomainAdminPassword'=> $params["password"],
        'PrimaryDomainAdminFirstName'=> $params['clientsdetails']['firstname'],
        'PrimaryDomainAdminLastName'=> $params['clientsdetails']['lastname'],
        'IP'=> $params["configoption2"],
        'ImapPort' => 143,
        'PopPort'=> 110,
        'SmtpPort' => 25,
        'MaxAliases' => $params["configoption6"],
        'MaxDomainSizeInMB' => $params["configoption4"],
        'MaxDomainUsers' => $params["configoption3"],
        'MaxMailboxSizeInMB' => 0,
        'MaxMessageSize' => $params["configoption7"],
        'MaxRecipients' => $params["configoption8"],
        'MaxDomainAliases' => $params["configoption5"],
        'MaxLists'  => $params["configoption9"],
        'ShowDomainAliasMenu'  => (($params["configoption12"] == "on") ? true : false),
        'ShowContentFilteringMenu'  => (($params["configoption13"] == "on") ? true : false),
        'ShowSpamMenu'  => (($params["configoption14"] == "on") ? true : false),
        'ShowStatsMenu'  => true,
        'RequireSmtpAuthentication'  => (($params["configoption11"] == "on") ? true : false),
        'ShowListMenu'  => (($params["configoption15"] == "on") ? true : false),
        'ListCommandAddress'  =>  $params["configoption10"]
    );

    $sm_createAccount_ws_url =  $smUrl."/Services/svcDomainAdmin.asmx?WSDL";
    $wsResult = sm_webServiceCall($sm_createAccount_ws_url,$paramaters,"AddDomain");

    if($wsResult['AddDomainResult']['Result']){
        $result = "success";
    } else {
        $result = $wsResult['AddDomainResult']['Message'];
    }
	
	
    return $result;
}

//Used when a product is terminated within WHMCS.  This calls 'deletedomain' web service on SmarterMail installation.
function smartermail_TerminateAccount($params) {

    $smUrl = addHttpToHostname($params["serverhostname"]);

    $paramaters = array(
        'AuthUserName' => $params["serverusername"],
        'AuthPassword' => $params["serverpassword"],
        'DomainName' => $params["domain"],
        'DeleteFiles' => true
    );

    $sm_TerminateAccount_ws_url = $smUrl."/Services/svcDomainAdmin.asmx?WSDL";
    $wsResult = sm_webServiceCall($sm_TerminateAccount_ws_url,$paramaters,"DeleteDomain");


    if($wsResult['DeleteDomainResult']['Result']){
        $result = "success";
    } else {
        $result = $wsResult['DeleteDomainResult']['Message'];
    }
    return $result;
}

//Used when an account is suspended within WHMCS.  This calls 'DisableDomain' web service on SmarterMail installation.
function smartermail_SuspendAccount($params) {

    $smUrl = addHttpToHostname($params["serverhostname"]);

    $paramaters = array(
        'AuthUserName' => $params["serverusername"],
        'AuthPassword' => $params["serverpassword"],
        'domainName' => $params["domain"]
    );

    $sm_SuspendAccount_ws_url = $smUrl."/Services/svcDomainAdmin.asmx?WSDL";
    $wsResult = sm_webServiceCall($sm_SuspendAccount_ws_url,$paramaters,"DisableDomain");


    if($wsResult['DisableDomainResult']['Result']){
        $result = "success";
    } else {
        $result = $wsResult['DisableDomainResult']['Message'];
    }
    return $result;
}

//Used when an product is unsuspended within WHMCS.  This calls 'EnableDomain' web service on SmarterMail installation.
function smartermail_UnsuspendAccount($params) {

    $smUrl = addHttpToHostname($params["serverhostname"]);

    $paramaters = array(
        'AuthUserName' => $params["serverusername"],
        'AuthPassword' => $params["serverpassword"],
        'domainName' => $params["domain"]
    );

    $sm_UnsuspendAccount_ws_url = $smUrl."/Services/svcDomainAdmin.asmx?WSDL";
    $wsResult = sm_webServiceCall($sm_UnsuspendAccount_ws_url,$paramaters,"EnableDomain");

    if($wsResult['EnableDomainResult']['Result']){
        $result = "success";
    } else {
        $result = $wsResult['EnableDomainResult']['Message'];
    }
    return $result;
}

//Used when the password is changed in WHMCS.  The new password must first be saved in WHMCS before the module is called.  This calls 'SetRequestedUserSettings' web service on SmarterMail installation.
function smartermail_ChangePassword($params) {

    $smUrl = addHttpToHostname($params["serverhostname"]);

    $paramaters = array(
        'AuthUserName' => $params["serverusername"],
        'AuthPassword' => $params["serverpassword"],
        'EmailAddress' => ($params["username"]."@".$params["domain"]),
        'newSettings' => array("password = ".$params["password"])
    );

    $sm_changePassword_ws_url = $smUrl."/Services/svcUserAdmin.asmx?WSDL";
    $wsResult = sm_webServiceCall($sm_changePassword_ws_url,$paramaters,"SetRequestedUserSettings");

    if ($wsResult['SetRequestedUserSettingsResult']['Result']) {
        $result = "success";
    } else {
        $result = $wsResult['SetRequestedUserSettingsResult']['Message'];
    }
    return $result;

}

//Used when a product is changed within WHMCS.  This calls 'updatedomain' web service on SmarterMail installation.
function smartermail_ChangePackage($params) {

    $smUrl = addHttpToHostname($params["serverhostname"]);

    $paramaters = array(
        'AuthUserName' => $params["serverusername"],
        'AuthPassword' => $params["serverpassword"],
        'DomainName'=> $params["domain"],
        'ServerIP'=> $params["configoption2"],
        'ImapPort' => 143,
        'PopPort'=> 110,
        'SmtpPort' => 25,
        'MaxAliases' => $params["configoption6"],
        'MaxDomainSizeInMB' => $params["configoption4"],
        'MaxDomainUsers' => $params["configoption3"],
        'MaxMailboxSizeInMB' => 0,
        'MaxMessageSize' => $params["configoption7"],
        'MaxRecipients' => $params["configoption8"],
        'MaxDomainAliases' => $params["configoption5"],
        'MaxLists'  => $params["configoption9"],
        'ShowDomainAliasMenu'  => (($params["configoption12"] == "on") ? true : false),
        'ShowContentFilteringMenu'  => (($params["configoption13"] == "on") ? true : false),
        'ShowSpamMenu'  => (($params["configoption14"] == "on") ? true : false),
        'ShowStatsMenu'  => true,
        'RequireSmtpAuthentication'  => (($params["configoption11"] == "on") ? true : false),
        'ShowListMenu'  => (($params["configoption15"] == "on") ? true : false),
        'ListCommandAddress'  =>  $params["configoption10"]
    );

    $sm_changePackage_ws_url = $smUrl."/Services/svcDomainAdmin.asmx?WSDL";
    $wsResult = sm_webServiceCall($sm_changePackage_ws_url,$paramaters,"UpdateDomain");

    if($wsResult['UpdateDomainResult']['Result']){
        $result = "success";
    } else {
        $result = $wsResult['UpdateDomainResult']['Message'];
    }
    return $result;

}

//Provides URL link in management interface for access to the SmarterMail web interface.
function smartermail_LoginLink($params) {

    $smUrl = addHttpToHostname($params["serverhostname"]);
    echo "<a href=$smUrl target=\"_blank\" style=\"color:#cc0000\">Access SmarterMail Web Interface</a>";

}


//Custom button array that allows users to interact with specified buttons below in client area.
function smartermail_ClientAreaCustomButtonArray() {
    $buttonarray = array(
        "Manage SmarterMail Users and Aliases" => "managesmartermail",
        "Add SmarterMail User" => "addsmartermailuser",
		"Add SmarterMail Alias" => "addsmartermailalias",
    );
    return $buttonarray;
}

function smartermail_ClientAreaAllowedFunctions()
{
	    $functionarray = array(
        "Create User (API)" => "createsmartermailuser",
        "Create Alias (API)" => "createsmartermailalias",
        "Edit Alias (API)" => "editsmartermailaliaspage",
        "Delete Alias (API)" => "deletesmartermailalias",
        "Edit User (API)" => "editsmartermailuserpage",
		"Delete User (API)" => "deletesmartermailuser",
        "Save User (API)" => "savechangessmartermailuser",
        "Save Alias (API)" => "savechangessmartermailalias",
    );
    return $functionarray;
}


//Manage SmarterMail button on client area details page.  Calls various web services to get users and aliases to be displayed in managesmartermail.tpl
function smartermail_managesmartermail($params) {

    $smUrl = addHttpToHostname($params["serverhostname"]);

    $paramaters = array(
        'AuthUserName' => $params["serverusername"],
        'AuthPassword' => $params["serverpassword"],
        'DomainName'=> $params["domain"],
    );

    //Call to get Domain Users
    $sm_getDomainUsers_ws_url = $smUrl."/Services/svcDomainAdmin.asmx?WSDL";
    $wsGetDomainUsersResult = sm_webServiceCall($sm_getDomainUsers_ws_url,$paramaters,"GetDomainUsers");

    //Call to get Domain Aliases
    $sm_GetAliases_ws_url = $smUrl."/Services/svcAliasAdmin.asmx?WSDL";
    $wsGetAliasesResult = sm_webServiceCall($sm_GetAliases_ws_url,$paramaters,"GetAliases");

    //Call to get LstServ address
    $sm_GetListCommandAddress_ws_url = $smUrl."/Services/svcMailListAdmin.asmx?WSDL";
    $wsGetListCommandAddressResult = sm_webServiceCall($sm_GetListCommandAddress_ws_url,$paramaters,"GetListCommandAddress");


//Set alias array for manage smartermail tpl

    $smAliasesArrayForLoop = array();
    $smAliasesArray = array();



    if(is_array($wsGetAliasesResult['GetAliasesResult']['AliasInfos']['AliasInfo'][0])){
        foreach($wsGetAliasesResult['GetAliasesResult']['AliasInfos']["AliasInfo"] as $key => $value)
        {
            foreach($value as $key2 => $value2)
            {
                if($key2 === 'Name')
                {
                    array_push($smAliasesArray,$value2);
                }
            }
        }
    }else{
        foreach($wsGetAliasesResult['GetAliasesResult']['AliasInfos']['AliasInfo'] as $key => $value)
        {
            if($key === 'Name')
            {
                array_push($smAliasesArray,$value);
            }
        }
    }

//setup user array to be displayed in ManageSmarterMail Template.  Checking to see if listServ name is showing or if they are an alias which shows in a separate section.
    $smUsersArray = array();
        foreach($wsGetDomainUsersResult["GetDomainUsersResult"]["Users"]['string'] as $userStringValue){
            if(($userStringValue != ($wsGetListCommandAddressResult['GetListCommandAddressResult']['commandAddress'])) and (!in_array( $userStringValue , $smAliasesArray))){
            array_push($smUsersArray, $userStringValue);
            }
        }

    sort($smUsersArray);

    $pagearray = array(
        'templatefile' => 'managesmartermail',
        'breadcrumb' => ' > <a href="#">Manage SmarterMail</a>',
        'vars' => array(
            'wsGetDomainUsersResultArray' => $smUsersArray,
            'wsGetAliasesResultArray' => $smAliasesArray,
            'domainName' => $params["domain"],
        ),
    );
    return $pagearray;
}


//called to display addsmartermailuser.tpl, allowing the ability to add new users to the domain.  Function of adding user is handled through smartermail_createsmartermailuser
function smartermail_addsmartermailuser($params) {
    $pagearray = array(
        'templatefile' => 'addsmartermailuser',
        'breadcrumb' => ' > <a href="#">Add SmarterMail User</a>',
        'vars' => array(
            'domain' => $params["domain"],
        ),
    );
    return $pagearray;
}

//used to create user through smartermail web service.  Information is passed through the POST action from the addsmartermailuser.tpl
function smartermail_createsmartermailuser($params) {
	
	
    $smUrl = addHttpToHostname($params["serverhostname"]);

    $paramaters = array(
        'AuthUserName' => $params["serverusername"],
        'AuthPassword' => $params["serverpassword"],
        'NewUsername' =>  $_POST['newusername'],
        'NewPassword' =>  $_POST['newpassword'],
        'DomainName' => $params["domain"],
        'FirstName' =>  $_POST['newfirstname'],
        'LastName' =>  $_POST['newlastname'],
        'IsDomainAdmin' => (($_POST['newdomaincheckbox'] == "on") ? true : false),
        'maxMailboxSize' =>  $_POST['newmailboxsize'],
    );
	
	if(is_null($_POST['newusername']))
	{
		$pagearray = array(
			'templatefile' => 'addsmartermailuser',
			'breadcrumb' => ' > <a href="#">Add SmarterMail User</a>',
			'vars' => array(
				'domain' => $params["domain"],
			),
		);
		return $pagearray;
	}
	
    $sm_AddUser2_ws_url = $smUrl."/Services/svcUserAdmin.asmx?WSDL";
    $wsResult = sm_webServiceCall($sm_AddUser2_ws_url,$paramaters,"AddUser2");
	
	if($wsResult['AddUser2Result']['Result']){
        $result = "success";
    } else {
        $result = $wsResult['AddUser2Result']['Message'];
    }
    return $result;
}

//called to display editsmartermailuserpage.tpl, allowing the ability to edit users to the domain.  Function of editng user is handled through smartermail_savesmartermailuser
function smartermail_editsmartermailuserpage($params) {
    $smUrl = addHttpToHostname($params["serverhostname"]);

    $paramatersForGetUser = array(
        'AuthUserName' => $params["serverusername"],
        'AuthPassword' => $params["serverpassword"],
        'EmailAddress' => ($_POST['selectuser'].'@'.$params['domain']),
    );

	if(is_null($_POST['selectuser']))
		return "Don't run API Calls. (try running the FORM instead)";
	
    $sm_GetUser_ws_url = $smUrl."/Services/svcUserAdmin.asmx?WSDL";
    $wsResult = sm_webServiceCall($sm_GetUser_ws_url,$paramatersForGetUser,"GetUser");

    //Get MAX mailbox size

    $paramatersForReqSettings = array(
        'AuthUserName' => $params["serverusername"],
        'AuthPassword' => $params["serverpassword"],
        'EmailAddress' => ($_POST['selectuser'].'@'.$params['domain']),
        'requestedSettings' => array('maxsize', 'enabledstatus'),
    );

    $sm_GetRequestedUserSettings_ws_url = $smUrl."/Services/svcUserAdmin.asmx?WSDL";
    $wsResult2 = sm_webServiceCall($sm_GetRequestedUserSettings_ws_url,$paramatersForReqSettings,"GetRequestedUserSettings");

    //Get Primary Admin to prevent account delete

    $paramatersForGetPrimaryAdmin = array(
        'AuthUserName' => $params["serverusername"],
        'AuthPassword' => $params["serverpassword"],
        'DomainName'=> $params["domain"],
    );

    $sm_GetPrimaryDomainAdmin_ws_url = $smUrl."/Services/svcDomainAdmin.asmx?WSDL";
    $wsResult3 = sm_webServiceCall($sm_GetPrimaryDomainAdmin_ws_url,$paramatersForGetPrimaryAdmin,"GetPrimaryDomainAdmin");

    $mailboxStatus = "Enabled";
    switch(ltrim(strrchr(($wsResult2['GetRequestedUserSettingsResult']['settingValues']['string'][1]), '='),'=')){
        case "Enabled":
            $mailboxStatus = 1;
            break;

        case "DisabledWMail":
            $mailboxStatus = 2;
            break;
        case "Disabled":
            $mailboxStatus = 3;
    }


    $pagearray = array(
        'templatefile' => 'editsmartermailuser',
        'breadcrumb' => ' > <a href="#">Edit SmarterMail User</a>',
        'vars' => array(
            'FirstName' => $wsResult['GetUserResult']['UserInfo']['FirstName'],
            'isDomainAdmin' => $wsResult['GetUserResult']['UserInfo']['IsDomainAdmin'],
            'LastName' => $wsResult['GetUserResult']['UserInfo']['LastName'],
            'Password' => $wsResult['GetUserResult']['UserInfo']['Password'],
            'UserName' => $wsResult['GetUserResult']['UserInfo']['UserName'],
            'maxMailboxSize' => ltrim(strrchr(($wsResult2['GetRequestedUserSettingsResult']['settingValues']['string'][0]), '='),'='),
            'mailboxStatus' => $mailboxStatus,
            'primarydomainadmin' => $wsResult3['GetPrimaryDomainAdminResult']['PrimaryAdmin'],
        ),
    );
    return $pagearray;
}

//used to edit user through smartermail web service.  Information is passed through the POST action from the editsmartermailuserpage.tpl
function smartermail_savechangessmartermailuser($params) {

    $smUrl = addHttpToHostname($params["serverhostname"]);


    $paramaters = array(
            'AuthUserName' => $params["serverusername"],
            'AuthPassword' => $params["serverpassword"],
            'EmailAddress' => $_POST['username'],
            'NewPassword' => $_POST['password'],
            'NewFirstName' => $_POST['firstname'],
            'NewLastName' => $_POST['lastname'],
            'IsDomainAdmin' => (($_POST["domaincheckbox"] == "on") ? true : false),
            'maxMailboxSize' => $_POST['mailboxsize'],
    );

	if(is_null($_POST['username']))
		return "Don't run API Calls. (try running the FORM instead)";
	
    $sm_UpdateUser2_ws_url = $smUrl."/Services/svcUserAdmin.asmx?WSDL";
    sm_webServiceCall($sm_UpdateUser2_ws_url, $paramaters, "UpdateUser2");


    $mailboxStatusArray = array();
    switch($_POST['mailboxstatus']){

        case "1":
            $mailboxStatusArray = array(
                'enabledstatus=Enabled'
            );
            break;

        case "2":
            $mailboxStatusArray = array(
                'enabledstatus=DisabledWMail'
            );
            break;
        case "3":
            $mailboxStatusArray = array(
                'enabledstatus=Disabled'
            );
            break;
    }

    $paramaters2 = array(
        'AuthUserName' => $params["serverusername"],
        'AuthPassword' => $params["serverpassword"],
        'EmailAddress' => $_POST['username'],
        'newSettings' => $mailboxStatusArray,
    );

    $sm_SetRequestedUserSettings_ws_url = $smUrl."/Services/svcUserAdmin.asmx?WSDL";
    $wsResult = sm_webServiceCall($sm_SetRequestedUserSettings_ws_url, $paramaters2, "SetRequestedUserSettings");
	if($wsResult['SetRequestedUserSettingsResult']['Result']){
        $result = "success";
    } else {
        $result = $wsResult['SetRequestedUserSettingsResult']['Message'];
    }
    return $result;
}

//called to delete user through smartermail web services.  This is initiated from the editsmartermailuser.tpl
function smartermail_deletesmartermailuser($params) {
    $smUrl = addHttpToHostname($params["serverhostname"]);

    $paramaters = array(
        'AuthUserName' => $params["serverusername"],
        'AuthPassword' => $params["serverpassword"],
        'Username' => strstr($_POST['username'], '@' , true),
        'DomainName' => $params["domain"],
    );

	if(is_null($_POST['username']))
		return "Don't run API Calls. (try running the FORM instead)";
	
    $sm_DeleteUser_ws_url = $smUrl."/Services/svcUserAdmin.asmx?WSDL";
    $wsResult = sm_webServiceCall($sm_DeleteUser_ws_url,$paramaters,"DeleteUser");
	if($wsResult['DeleteUserResult']['Result']){
        $result = "success";
    } else {
        $result = $wsResult['DeleteUserResult']['Message'];
    }
    return $result;
}

//called to display addsmartermailalias.tpl, allowing the ability to add new user aliases to the domain.  Function of adding alias is handled through smartermail_createsmartermailalias
function smartermail_addsmartermailalias($params) {
    $pagearray = array(
        'templatefile' => 'addsmartermailalias',
        'breadcrumb' => ' > <a href="#">Add SmarterMail User Alias</a>',
        'vars' => array(),
    );
    return $pagearray;
}

//used to create user alias through smartermail web service.  Information is passed through the POST action from the addsmartermailalias.tpl
function smartermail_createsmartermailalias($params) {

    $smUrl = addHttpToHostname($params["serverhostname"]);

    $paramaters = array(
        'AuthUserName' => $params["serverusername"],
        'AuthPassword' => $params["serverpassword"],
        'DomainName' => $params["domain"],
        'AliasName' =>  $_POST['newaliasname'],
        'Addresses' => explode("\r\n", $_POST['newaliasemailaddress']),
    );

	if(is_null($_POST['newaliasname']))
	{
		$pagearray = array(
			'templatefile' => 'addsmartermailalias',
			'breadcrumb' => ' > <a href="#">Add SmarterMail User Alias</a>',
			'vars' => array(),
		);
		return $pagearray;
	}
	
	
    $sm_AddAlias_ws_url = $smUrl."/Services/svcAliasAdmin.asmx?WSDL";
    $wsResult = sm_webServiceCall($sm_AddAlias_ws_url,$paramaters,"AddAlias");
	if($wsResult['AddAliasResult']['Result']){
        $result = "success";
    } else {
        $result = $wsResult['AddAliasResult']['Message'];
    }
    return $result;
}

//called to display editsmartermailaliaspage.tpl, allowing the ability to edit user aliases to the domain.  Function of editing user alias is handled through smartermail_savesmartermailalias
function smartermail_editsmartermailaliaspage($params) {

    $smUrl = addHttpToHostname($params["serverhostname"]);

    $paramaters = array(
        'AuthUserName' => $params["serverusername"],
        'AuthPassword' => $params["serverpassword"],
        'DomainName' => $params["domain"],
        'AliasName' =>  $_POST['selectalias'],

    );

	if(is_null($_POST['selectalias']))
		return "Don't run API Calls. (try running the FORM instead)";
	
    $sm_GetAlias_ws_url = $smUrl."/Services/svcAliasAdmin.asmx?WSDL";
    $wsResult = sm_webServiceCall($sm_GetAlias_ws_url,$paramaters,"GetAlias");

    $pagearray = array(
        'templatefile' => 'editsmartermailalias',
        'breadcrumb' => ' > <a href="#">Edit SmarterMail User Alias</a>',
        'vars' => array(
            'name' => $wsResult['GetAliasResult']['AliasInfo']['Name'],
            'addresses' => $wsResult["GetAliasResult"]["AliasInfo"]["Addresses"]['string'],
        ),
    );
    return $pagearray;
}
//used to edit user alias through smartermail web service.  Information is passed through the POST action from the editsmartermailaliasrpage.tpl
function smartermail_savechangessmartermailalias($params) {

    $smUrl = addHttpToHostname($params["serverhostname"]);

    $paramaters = array(
        'AuthUserName' => $params["serverusername"],
        'AuthPassword' => $params["serverpassword"],
        'DomainName' => $params["domain"],
        'AliasName' =>  $_POST['aliasname'],
        'Addresses' => explode("\r\n", $_POST['aliasemailaddress']),
    );

	if(is_null($_POST['aliasname']))
		return "Don't run API Calls. (try running the FORM instead)";
	
    $sm_UpdateAlias_ws_url = $smUrl."/Services/svcAliasAdmin.asmx?WSDL";
    $wsResult = sm_webServiceCall($sm_UpdateAlias_ws_url,$paramaters,"UpdateAlias");
	if($wsResult['UpdateAliasResult']['Result']){
        $result = "success";
    } else {
        $result = $wsResult['UpdateAliasResult']['Message'];
    }
    return $result;
}

//called to delete alias through smartermail web services.  This is initiated from the editsmartermailalias.tpl
function smartermail_deletesmartermailalias($params) {

    $smUrl = addHttpToHostname($params["serverhostname"]);

    $paramaters = array(
        'AuthUserName' => $params["serverusername"],
        'AuthPassword' => $params["serverpassword"],
        'DomainName' => $params["domain"],
        'AliasName' =>  $_POST['aliasname'],
    );

	if(is_null($_POST['aliasname']))
		return "Don't run API Calls. (try running the FORM instead)";
	
    $sm_DeleteAlias_ws_url = $smUrl."/Services/svcAliasAdmin.asmx?WSDL";
    $wsResult = sm_webServiceCall($sm_DeleteAlias_ws_url,$paramaters,"DeleteAlias");
	if($wsResult['DeleteAliasResult']['Result']){
        $result = "success";
    } else {
        $result = $wsResult['DeleteAliasResult']['Message'];
    }
    return $result;
}

///////////////////////////////////// - SM Functions created for common use - /////////////////////////////////////
//  Function to call web service
function sm_webServiceCall($url, $paramaters, $ws_name)
{
    $soap_client = new SoapClient($url);
    $result = $soap_client->__SoapCall($ws_name, array('paramaters' => $paramaters));
	//echo "res: ".print_r(sm_toArray($result));
    return sm_toArray($result);
}

//	Converts JSON Data Structure from .NET Web Service to Array
function sm_toArray($obj){
    $return=array();
    if (is_array($obj)) {
        $keys=array_keys($obj);
    } elseif (is_object($obj)) {
        $keys=array_keys(get_object_vars($obj));
    } else {return $obj;}
    foreach ($keys as $key) {
        $value=$obj->$key;
        if (is_array($obj)) {
            $return[$key]=sm_toArray($obj[$key]);
        } else {
            $return[$key]=sm_toArray($obj->$key);
        }
    }
    return $return;
}
function addHttpToHostname($url) {
    if(substr($url, 0, 7) != 'http://') {
        $url = 'http://' . $url . "/";
    }
    return $url;
}
?>
